<div align="center">
<img styles="max-height=640px" src="https://github.com/zsmatrix62/echoo.app/blob/main/docs/img/gh-head.png?raw=true" />
</div>

<div align="center">
<br>
<!-- [![Download Counts](https://img.shields.io/github/downloads/zsmatrix62/echoo-app/total?style=flat)](https://github.com/zsmatrix62/echoo-app/releases) -->

[![Stars Count](https://img.shields.io/github/stars/zsmatrix62/echoo-app?style=flat)](https://github.com/zsmatrix62/echoo-app/stargazers)
[![Issues Count](https://img.shields.io/github/issues/zsmatrix62/echoo-app.svg?style=flat)](https://github.com/zsmatrix62/echoo-app/issues)

[![License: AGPL v3](https://img.shields.io/badge/License-AGPL%20v3-blue.svg)](https://www.gnu.org/licenses/agpl-3.0)
[![Version](https://img.shields.io/github/release/echoo-app/echoo-app.svg?style=flat-square)](https://github.com/zsmatrix62/echoo-app/releases)

[![Windows Support](https://img.shields.io/badge/Windows-0078D6?style=flat&logo=windows&logoColor=white)](https://github.com/zsmatrix62/echoo-app/releases)
[![macOS Support](https://img.shields.io/badge/MACOS-adb8c5?style=flat&logo=macos&logoColor=white)](https://apps.apple.com/cn/app/echoo-app/id1612383544?mt=12)
[![Linux Support](https://img.shields.io/badge/linux-1793D1?style=flat&logo=linux&logoColor=white)](https://github.com/zsmatrix62/echoo-app/releases)

</div>

## 💻 Native/Offline Client

Client provides full `offline` features without any remote API calls on your Mac or PC.

### MacOS

<a href="https://apps.apple.com/cn/app/echoo-app/id1612383544?mt=12" target="_blank">
<img height=40 src="./docs/img/mac-app-store-badge.svg" />
</a>

### Windows / Linux

Download them from
the [Github Release](https://github.com/echoo-app/echoo-app/releases) for `Windows` and `Linux`.

## 🌏 Online Web

**[web.echoo.app](https://web.echoo.app)** hosts the same functionalities of client version.

## 🔑 Privacy and Data Safety

`Echoo.app` clients (web / native) can be completely offline, any of the data you input will **NOT** be collected, including your codes, binary, image etc, anonymouse analysis will only be done only if you opt-in or enabled it ([check source code here](https://github.com/zsmatrix62/echoo.app/blob/4df7e95077809881d5a9f246823001b17d58e8bd/web-src/src/App.tsx#L98)).

## 🎉 Features / Todos

Click link to check screenshots

### Formatters

- [x] [JSON Formatter Validator](docs/json-formatter.md)
- [x] [Base64 (Image) Encoder and Decoder](docs/base64-ende.md)
- [x] [URL Parser, Encoder and Decoder](docs/url-parser.md)
- [x] Cron Job Parser
- [ ] JWT Debugger
- [ ] RegExp Tester
- [ ] SQL Formatter

### Generators

- [ ] UUID/ULID Generator/Decoder
- [ ] Hash Generator

### Converters

- [ ] Number Base Converter
- [ ] Unix Time Converter
- [ ] JSON <- -> YAML

## LICENSE

[AGPL-3.0](https://github.com/zsmatrix62/echoo-app/blob/main/LICENSE)

## Support

Please upvote us on:

<a href="https://www.producthunt.com/posts/echoo-app?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-echoo&#0045;app" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=334856&theme=light" alt="Echoo&#0046;app - Open&#0045;source&#0032;&#0038;&#0032;cross&#0045;platform&#0032;app&#0032;of&#0032;tools&#0032;for&#0032;developers | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

---

## Examples

  <table>
  <tr>
    <td>
     <img src="docs/img/json-1.png" width=680px>
    </td>
    <td>
      <img src="docs/img/json-2.png" width=680px>
    </td>
  </tr>
  <tr> <td> <img src="docs/img/base64-img.png" width=680px></td>
    <td> <img src="docs/img/base64-str.png" width=680px></td>
  </tr>
  <tr>
    <td>
      <img src="docs/img/url-parser.png" width=680px>
      </td>
  </tr>
</table>
